#define _GNU_SOURCE
#include <stdio.h>
#include <sched.h>
#include <time.h>

int main(int argc, char *argv[])
{
	pid_t pid;
	int nocpus;
	cpu_set_t cpuset;
	int r = 0;
	int i;
	struct timespec tm;
	int count = 0;
	
	if (argc < 3) {
		fprintf(stderr, "Usage: cycleaffinity no_of_cpus pid\n");
		return 1;
	}
	nocpus = atoi(argv[1]);
	pid = atoi(argv[2]);
	printf("pid: %d\n", pid);

	tm.tv_sec = 0;
	tm.tv_nsec = 10;
	
	CPU_ZERO(&cpuset);
	while (r == 0) {
		for (i = 0; i < nocpus; ++i) {
			if (i == 0)
				CPU_CLR(nocpus - 1, &cpuset);
			else
				CPU_CLR(i - 1, &cpuset);
			CPU_SET(i, &cpuset);
			
			r = sched_setaffinity(pid, sizeof(cpu_set_t), &cpuset);
			if (r) {
				perror("sched_setaffinity");
				break;
			}
			count++;
			nanosleep(&tm, NULL);
		}
	}
	printf("changed affinity: %d\n", count);
	
	return 0;
}
